# -*- coding=UTF-8 -*-
# This typing file was generated by typing_from_help.py
"""
paddleocr

"""

from . import tools
import typing

from numpy import ndarray

"""
# Copyright (c) 2020 PaddlePaddle Authors. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

"""

class PaddleOCR(tools.infer.predict_system.TextSystem):
    """
    PaddleOCR(**kwargs)
    """

    def __init__(self, **kwargs: typing.Any):
        """
        paddleocr package
        args:
            **kwargs: other params show in paddleocr --help
        """
        ...
    def ocr(
        self,
        img: typing.Union[typing.Text, ndarray],
        det: bool = True,
        rec: bool = True,
        cls: bool = False,
    ) -> typing.List[typing.Tuple[typing.Text, float]]:
        """
        ocr with paddleocr
        args：
            img: img for ocr, support ndarray, img_path and list or ndarray
            det: use text detection or not, if false, only rec will be exec. default is True
            rec: use text recognition or not, if false, only det will be exec. default is True
        """
        ...
    ...

def draw_ocr(
    image, boxes, txts=None, scores=None, drop_score=0.5, font_path="./doc/simfang.ttf"
):
    """
    Visualize the results of OCR detection and recognition
    args:
        image(Image|array): RGB image
        boxes(list): boxes with shape(N, 4, 2)
        txts(list): the texts
        scores(list): txxs corresponding scores
        drop_score(float): only scores greater than drop_threshold will be visualized
        font_path: the path of font which is used to draw text
    return(array):
        the visualized img
    """
    ...

__all__: ...
"""
['PaddleOCR', '__all__', '__builtins__', '__cached__', '__do...
"""
